const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const serials = sequelize.define(
    'serials',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

serial_number: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"available",


"quarantined",


"released",


"consumed",


"scrapped",


"shipped"

        ],

      },

manufactured_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  serials.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























    db.serials.hasMany(db.inventory_balances, {
      as: 'inventory_balances_serial',
      foreignKey: {
          name: 'serialId',
      },
      constraints: false,
    });


    db.serials.hasMany(db.inventory_movements, {
      as: 'inventory_movements_serial',
      foreignKey: {
          name: 'serialId',
      },
      constraints: false,
    });






    db.serials.hasMany(db.inspections, {
      as: 'inspections_serial',
      foreignKey: {
          name: 'serialId',
      },
      constraints: false,
    });



    db.serials.hasMany(db.nonconformances, {
      as: 'nonconformances_serial',
      foreignKey: {
          name: 'serialId',
      },
      constraints: false,
    });






//end loop



    db.serials.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.serials.belongsTo(db.lots, {
      as: 'lot',
      foreignKey: {
        name: 'lotId',
      },
      constraints: false,
    });




    db.serials.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.serials.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return serials;
};


